import com.nerius.math.geom.*;
import com.nerius.math.xform.*;

public final class CylinderShinglesGenerator extends GenerationUtils {

  public static void main(String[] args) {
    final int radius = Integer.parseInt(args[0]);
    final int slices = Integer.parseInt(args[1]);
    final int height = Integer.parseInt(args[2]);
    final boolean adjustForOverlappingCylinderCuts = Boolean.valueOf(args[3]);
    final Point3D[] curve = generatePipeCurve
      (radius, slices, 0, 0.0d,
       adjustForOverlappingCylinderCuts ? ADJUST_FOR_OVERLAPPING_PIPE_CUTS :
       ADJUST_NONE);
    final AxisRotation3D rot = new AxisRotation3D
      (AxisRotation3D.X_AXIS, Math.PI / 2);
    for (int i = 0; i <= slices; i++) {
      curve[i] = rot.transform(curve[i]);
    }
    startMap();
    for (int i = 0; i < slices / 2; i++) {
      writeBrushExtendZ(-height,
                        curve[i],
                        new Point3D(curve[i + 1].x - 1,
                                    curve[i + 1].y,
                                    0),
                        curve[i + 1],
                        false);
    }
    for (int i = slices / 2; i < slices; i++) {
      writeBrushExtendZ(-height,
                        curve[i],
                        new Point3D(curve[i + 1].x,
                                    curve[i + 1].y - 1,
                                    0),
                        curve[i + 1],
                        false);
    }
    endMap();
  }

}
