import com.nerius.math.geom.*;
import com.nerius.math.xform.*;

class ExtrudeRadiusFactorCalculator {

  public static void main(String[] args) {
    final int radius = Integer.parseInt(args[0]);
    final int slices = Integer.parseInt(args[1]);
    final int extrudeTopNSlices = Integer.parseInt(args[2]);
    final int lipOffset = Integer.parseInt(args[3]);
    Point3D pt0 = new Point3D(radius, 0, 0);
    AxisRotation3D rot =
      new AxisRotation3D(AxisRotation3D.Y_AXIS,
                         (Math.PI * extrudeTopNSlices) / (2 * slices));
    pt0 = rot.transform(pt0);
    Point3D pt1 = new Point3D(radius + lipOffset, 0, 0);
    Point3D pt2 = new Point3D(pt0.x - pt0.z,
                              0,
                              pt0.z + pt0.x);
    double a = Math.sqrt((pt0.x - pt1.x) * (pt0.x - pt1.x) +
                         (pt0.z - pt1.z) * (pt0.z - pt1.z));
    double c = Math.sqrt((pt1.x - pt2.x) * (pt1.x - pt2.x) +
                         (pt1.z - pt2.z) * (pt1.z - pt2.z));
    double b = Math.sqrt((pt2.x - pt0.x) * (pt2.x - pt0.x) +
                         (pt2.z - pt0.z) * (pt2.z - pt0.z));
    double cosAlpha = (a * a + b * b - c * c) / (2 * a * b);
    double alpha = Math.acos(cosAlpha);
    double sinAlpha = Math.sin(alpha);
    double newRadius = a / (2 * sinAlpha);
    System.out.println("extrudeRadiusFactor: " + (newRadius / radius));
  }

}
