import com.nerius.math.geom.*;
import com.nerius.math.xform.*;

/**
 * Generates shingles for a quarter pipe ramp.
 */
public final class PipeShinglesGenerator extends GenerationUtils {

  public static void main(String[] args) {
    final int radius = Integer.parseInt(args[0]);
    final int slices = Integer.parseInt(args[1]);
    final int length = Integer.parseInt(args[2]);
    final int extrudeTopNSlices = Integer.parseInt(args[3]);
    final double extrudeRadiusFactor = Double.parseDouble(args[4]);
    final boolean adjustForOverlappingPipeCuts = Boolean.valueOf(args[5]);
    final boolean adjustForOverlappingBowlCuts = Boolean.valueOf(args[6]);
    int adjustMask = 0;
    if (adjustForOverlappingBowlCuts) {
      adjustMask |= ADJUST_FOR_OVERLAPPING_BOWL_CUTS;
    }
    if (adjustForOverlappingPipeCuts) {
      adjustMask |= ADJUST_FOR_OVERLAPPING_PIPE_CUTS;
    }
    final Point3D[] curve = generatePipeCurve(radius,
                                              slices,
                                              extrudeTopNSlices,
                                              extrudeRadiusFactor,
                                              adjustMask);
    startMap();
    writeBrushExtendY(length,
                      curve[0],
                      curve[1],
                      new Point3D(curve[1].x - 1, 0, curve[1].z),
                      new Point3D(curve[0].x - 1, 0, curve[0].z));
    for (int i = 1; i < slices; i++) {
      if (curve[i].z > curve[i + 1].z) {
        writeBrushExtendY(length,
                          curve[i],
                          curve[i + 1],
                          new Point3D(curve[i + 1].x - 1,
                                      0,
                                      curve[i + 1].z),
                          false);
      }
    }
    endMap();
  }

}
